
//-*-c++-*-  
//  Copyright (c) 1994 by Mike Romberg (  romberg@md.fsl.noaa.gov )
//
//  This file may be distributed under terms of the GPL
//

#ifndef _XTypeWatch_H_
#define _XTypeWatch_H_

#include "xwin.h"
#include "break.hh"

class Meter;
class Recorder;

class XTypeWatch : public XWin {
public:
    XTypeWatch( int argc, char *argv[] );
    ~XTypeWatch( void );

    void resize( void );
    void draw( void );
    void run( void );

    const char *winname( void );
    void forcePause(const Break *);  
    Break micro_, normal_; 

    Recorder  *recorder_;
    void warn() const;
protected:

    class MeterNode {
    public:
	MeterNode( Meter *fm ) { meter_ = fm;  next_ = NULL; }

	Meter *meter_;
	MeterNode *next_;
};


    MeterNode *meters_;
  
    int legend_, xoff_, yoff_, nummeters_, doterm_, usedlabels_, ints_;
    int serial_[4];
    float netmax_;

    void usleep( unsigned long usec );
    void addmeter( Meter *fm );
    void checkMeterResources( void );

    int findx( void );
    int findy( void );
    void dolegends( void );
    int newypos( void );
    void parseargs( int argc, char *argv[] );

    void resizeEvent( XEvent & ) { resize(); draw(); }
    void exposeEvent( XExposeEvent &event ) { if ( event.count == 0 ) draw(); }
    void keyPressEvent( XKeyEvent &event );
    void winCreateEvent(XCreateWindowEvent &event);

private:
    void select_recorderEvents() ;
    void track_branch(Window w);
    void track_window(Window w);
    void updateRecorder();
    unsigned myTime_;		// in milliseconds
};

#endif
